Index: calculatorview/src/sans/perspectives/calculator/sld_panel.py
===================================================================
--- calculatorview/src/sans/perspectives/calculator/sld_panel.py	(revision 7d45a560fc54369038cd457bd4c8f382c01d9367)
+++ calculatorview/src/sans/perspectives/calculator/sld_panel.py	(revision 4752c3147b9fc43a430792f9b3b9dc74c64e094a)
@@ -60,4 +60,6 @@
         self.compound_ctl = None
         self.density_ctl = None
+        self.compound = ""
+        self.density = ""
         self.wavelength_ctl = None
         self.neutron_sld_real_ctl = None
@@ -305,5 +307,5 @@
         energy = xray_energy(element.K_alpha)
         
-        self.sld_formula = formula(str(user_formula), density=self.density)
+        self.sld_formula = formula(str(self.compound), density=self.density)
         atom = self.sld_formula.atoms
         return xray_sld_from_atoms(atom, density=self.density, energy= energy)
@@ -320,5 +322,5 @@
     
         self.wavelength = self.wavelength_ctl.GetValue()
-        if self.wavelength.lstrip().rstrip() == "":
+        if str(self.wavelength).lstrip().rstrip() == "":
             self.wavelength = WAVELENGTH
             self.wavelength_ctl.SetValue(str(WAVELENGTH))
Index: sansguiframe/src/sans/guiframe/data_manager.py
===================================================================
--- sansguiframe/src/sans/guiframe/data_manager.py	(revision b5b2e5b316fee7d0793ca1a1eb262ba768a6193d)
+++ sansguiframe/src/sans/guiframe/data_manager.py	(revision 4752c3147b9fc43a430792f9b3b9dc74c64e094a)
@@ -275,6 +275,5 @@
             for id, data_state in self.stored_data.iteritems():
                 if data_state.data.name == selected_name:
-                    del self._selected_data[id]
-                    del self.stored_data[data.id]
+                    del self.stored_data[id]
 
     def get_data_state(self, data_id):
Index: sansguiframe/src/sans/guiframe/local_perspectives/plotting/BaseInteractor.py
===================================================================
--- sansguiframe/src/sans/guiframe/local_perspectives/plotting/BaseInteractor.py	(revision 8c347a61193367bd8a75b5a9949e34a45f6b9385)
+++ sansguiframe/src/sans/guiframe/local_perspectives/plotting/BaseInteractor.py	(revision 4752c3147b9fc43a430792f9b3b9dc74c64e094a)
@@ -135,5 +135,5 @@
             self.move(ev.xdata, ev.ydata, ev)
         else:
-            self.restore()
+            self.restore(ev)
         self.base.update()
         return True
@@ -147,5 +147,5 @@
         """
         if ev.key == 'escape':
-            self.restore()
+            self.restore(ev)
         elif ev.key in ['up', 'down', 'right', 'left']:
             dx, dy = self.dpixel(self.clickx, self.clicky, nudge=ev.control)
Index: sansguiframe/src/sans/guiframe/local_perspectives/plotting/SectorSlicer.py
===================================================================
--- sansguiframe/src/sans/guiframe/local_perspectives/plotting/SectorSlicer.py	(revision 940aca737db034347a7b2bcbe30f143b76e47cbc)
+++ sansguiframe/src/sans/guiframe/local_perspectives/plotting/SectorSlicer.py	(revision 4752c3147b9fc43a430792f9b3b9dc74c64e094a)
@@ -495,5 +495,5 @@
         """
         x = params["radius"] 
-        self.set_cursor(x, self._inner_mouse_y)
+        self.set_cursor(x, None)
         
 
@@ -624,4 +624,4 @@
         """
         x = params["radius"] 
-        self.set_cursor(x, self._inner_mouse_y)
-        
+        self.set_cursor(x, None)
+        
Index: sansguiframe/src/sans/guiframe/local_perspectives/plotting/masking.py
===================================================================
--- sansguiframe/src/sans/guiframe/local_perspectives/plotting/masking.py	(revision bf7ad65fb7f8e9d69d991260cf4bccd57d66161a)
+++ sansguiframe/src/sans/guiframe/local_perspectives/plotting/masking.py	(revision 4752c3147b9fc43a430792f9b3b9dc74c64e094a)
@@ -21,5 +21,5 @@
 import sys
 import time
-import pylab
+import matplotlib.cm as cm
 import math
 import copy
@@ -34,5 +34,5 @@
 (InternalEvent, EVT_INTERNAL) = wx.lib.newevent.NewEvent()
 
-DEFAULT_CMAP = pylab.cm.jet
+DEFAULT_CMAP = cm.jet
 _BOX_WIDTH = 76
 _SCALE = 1e-6
@@ -647,5 +647,5 @@
         try:
             self.plotpanel.subplot.figure.clf()
-            self.plotpanel.close()
+            self.plotpanel.Close()
         except:
             # when called by data panel
Index: sansguiframe/src/sans/guiframe/local_perspectives/plotting/plotting.py
===================================================================
--- sansguiframe/src/sans/guiframe/local_perspectives/plotting/plotting.py	(revision 940aca737db034347a7b2bcbe30f143b76e47cbc)
+++ sansguiframe/src/sans/guiframe/local_perspectives/plotting/plotting.py	(revision 4752c3147b9fc43a430792f9b3b9dc74c64e094a)
@@ -26,6 +26,6 @@
 IS_WIN = True    
 if sys.platform.count("win32")==0:
-    if int(wx.__version__.split('.')[0]) == 2:
-        if int(wx.__version__.split('.')[1]) < 9:
+    if int(str(wx.__version__).split('.')[0]) == 2:
+        if int(str(wx.__version__).split('.')[1]) < 9:
             IS_WIN = False
 