Index: guiframe/dummyapp.py
===================================================================
--- guiframe/dummyapp.py	(revision d955bf190082f518b5b97bfa21e5d38962be57f2)
+++ guiframe/dummyapp.py	(revision 4753fc26255020c3536a5e7e6795cb5b16be90c9)
@@ -4,13 +4,19 @@
 """
 import gui_manager
+from sans.guiframe.gui_style import GUIFRAME
+from sans.guiframe.plugin_base import PluginBase
 
-class TestPlugin(gui_manager.Plugin):
+class DummyView(gui_manager.ViewApp):
+    """
+    """
+    PROG_SPLASH_PATH = None
+    STYLE = GUIFRAME.SINGLE_APPLICATION
     
-    def populate_menu(self, id, parent):
+class TestPlugin(PluginBase):
+    
+    def populate_menu(self, parent):
         """
         Create and return the list of application menu
         items for the plug-in. 
-        
-        :param id: deprecated. Un-used.
         :param parent: parent window
         
@@ -32,5 +38,5 @@
     
         # Returns the menu and a name for it.
-        return [(id, plug_menu, "DummyApp")]    
+        return [(plug_menu, "DummyApp")]    
     
     def get_panels(self, parent):
@@ -103,5 +109,5 @@
         Initialization
         """
-        self.gui = gui_manager.ViewApp(0)
+        self.gui = DummyView(0)
         
         fitting_plug = TestPlugin()
Index: guiframe/gui_manager.py
===================================================================
--- guiframe/gui_manager.py	(revision 338579596b031e445e3dbc76b1b6f35d870f65e3)
+++ guiframe/gui_manager.py	(revision 4753fc26255020c3536a5e7e6795cb5b16be90c9)
@@ -53,4 +53,5 @@
 GUIFRAME_WIDTH = 1000
 GUIFRAME_HEIGHT = 800
+PROG_SPLASH_SCREEN = "images/danse_logo.png" 
 
 class ViewerFrame(wx.Frame):
@@ -60,5 +61,5 @@
     
     def __init__(self, parent, title, 
-                 size=(GUIFRAME_WIDTH,GUIFRAME_HEIGHT),
+                 size=(GUIFRAME_WIDTH, GUIFRAME_HEIGHT),
                  gui_style=GUIFRAME.DEFAULT_STYLE, 
                  pos=wx.DefaultPosition):
@@ -581,5 +582,4 @@
             for (menu, name) in self._plotting_plugin.populate_menu(self):
                 self._window_menu.AppendSubMenu(menu, name)
-        self._window_menu.AppendSeparator()
         self._menubar.Append(self._window_menu, '&Window')
      
@@ -590,15 +590,18 @@
             wx.EVT_MENU(self, id, self.show_data_panel)
             
-        id = wx.NewId()
-        preferences_menu = wx.Menu()
-        hint = "Plot panels will floating"
-        preferences_menu.Append(id, '&Floating Plot Panel', hint)
-        wx.EVT_MENU(self, id, self.set_plotpanel_floating)
-        id = wx.NewId()
-        hint = "Plot panels will displayed within the frame"
-        preferences_menu.Append(id, '&Fixed Plot Panel', hint)
-        wx.EVT_MENU(self, id, self.set_plotpanel_fixed)
-        id = wx.NewId()
-        self._window_menu.AppendSubMenu(preferences_menu,'&Preferences')
+        style = self.__gui_style & GUIFRAME.PLOTTING_ON
+        if style == GUIFRAME.PLOTTING_ON:
+            self._window_menu.AppendSeparator()
+            id = wx.NewId()
+            preferences_menu = wx.Menu()
+            hint = "Plot panels will floating"
+            preferences_menu.Append(id, '&Floating Plot Panel', hint)
+            wx.EVT_MENU(self, id, self.set_plotpanel_floating)
+            id = wx.NewId()
+            hint = "Plot panels will displayed within the frame"
+            preferences_menu.Append(id, '&Fixed Plot Panel', hint)
+            wx.EVT_MENU(self, id, self.set_plotpanel_fixed)
+            id = wx.NewId()
+            self._window_menu.AppendSubMenu(preferences_menu,'&Preferences')
         #wx.EVT_MENU(self, id, self.show_preferences_panel)   
         """
@@ -670,5 +673,5 @@
         wx.EVT_MENU(self, data_file_id, self._load_data)
         style = self.__gui_style & GUIFRAME.MULTIPLE_APPLICATIONS
-        style1 = self.__gui_style & GUIFRAME.SINGLE_APPLICATION
+        style1 = self.__gui_style & GUIFRAME.DATALOADER_ON
         if style == GUIFRAME.MULTIPLE_APPLICATIONS:
             #menu for data from folder
@@ -679,5 +682,5 @@
             wx.EVT_MENU(self, data_folder_id, self._load_folder)
             self._menubar.Append(self._data_menu, '&Data')
-        elif style1 == GUIFRAME.SINGLE_APPLICATION:
+        elif style1 == GUIFRAME.DATALOADER_ON:
             self._menubar.Append(self._data_menu, '&Data')
         
@@ -1236,5 +1239,5 @@
     CENTER_PANE = True
 
-PROG_SPLASH_SCREEN = "images/danse_logo.png" 
+
 # Toy application to test this Frame
 class ViewApp(wx.App):