Index: src/sas/sasgui/perspectives/fitting/media/fitting_help.rst
===================================================================
--- src/sas/sasgui/perspectives/fitting/media/fitting_help.rst	(revision ca383a0379b7c34a82f7245aa76f89169ddeb5d1)
+++ src/sas/sasgui/perspectives/fitting/media/fitting_help.rst	(revision 5005ae0a7e3ed07742271fca99651ba5c55aa8b0)
@@ -3,15 +3,4 @@
 .. This is a port of the original SasView html help file to ReSTructured text
 .. by S King, ISIS, during SasView CodeCamp-III in Feb 2015.
-
-.. |inlineimage004| image:: sm_image004.png
-.. |inlineimage005| image:: sm_image005.png
-.. |inlineimage008| image:: sm_image008.png
-.. |inlineimage009| image:: sm_image009.png
-.. |inlineimage010| image:: sm_image010.png
-.. |inlineimage011| image:: sm_image011.png
-.. |inlineimage012| image:: sm_image012.png
-.. |inlineimage018| image:: sm_image018.png
-.. |inlineimage019| image:: sm_image019.png
-
 
 Fitting
@@ -38,5 +27,7 @@
    for example, if you have measured the same sample at different contrasts)
 
-*  in *Batch* fit mode - multiple data sets are fitted sequentially to the *same* model (this might be useful, for example, if you have performed a kinetic or time-resolved experiment and have *lots* of data sets!)
+*  in *Batch* fit mode - multiple data sets are fitted sequentially to the
+   *same* model (this might be useful, for example, if you have performed
+   a kinetic or time-resolved experiment and have *lots* of data sets!)
 
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
@@ -54,5 +45,6 @@
 *  *Lamellae* - lamellar shapes (lamellar, core shell lamellar, stacked
    lamellar, etc)
-*  *Shape-Independent* - models describing structure in terms of density correlation functions, fractals, peaks, power laws, etc
+*  *Shape-Independent* - models describing structure in terms of density
+   correlation functions, fractals, peaks, power laws, etc
 *  *Paracrystal* - semi ordered structures (bcc, fcc, etc)
 *  *Structure Factor* - S(Q) models
@@ -143,5 +135,5 @@
    and/or relatively simple models)
 *  By copying/editing an existing model (this can include models generated by
-   the New Plugin Model* dialog) in the :ref:`Python_shell` or 
+   the New Plugin Model* dialog) in the :ref:`Python_shell` or
    :ref:`Advanced_Plugin_Editor` (suitable for all use cases)
 *  By writing a model from scratch outside of SasView (only recommended for code
@@ -181,9 +173,9 @@
 .. image:: new_model.png
 
-When using this feature, be aware that even if your code has errors, including 
-syntax errors, a model file is still generated. When you then correct the errors 
-and click 'Apply' again to re-compile you will get an error informing you that 
-the model already exists if the 'Overwrite' box is not checked. In this case you 
-will need to supply a new model function name. By default the 'Overwrite' box is 
+When using this feature, be aware that even if your code has errors, including
+syntax errors, a model file is still generated. When you then correct the errors
+and click 'Apply' again to re-compile you will get an error informing you that
+the model already exists if the 'Overwrite' box is not checked. In this case you
+will need to supply a new model function name. By default the 'Overwrite' box is
 *checked*\ .
 
@@ -195,7 +187,7 @@
 the :ref:`Advanced_Plugin_Editor` .
 
-**SasView version 4.2** made it possible to specify whether a plugin created with 
-the *New Plugin Model* dialog is actually a form factor P(Q) or a structure factor 
-S(Q). To do this, simply add one or other of the following lines under the *import* 
+**SasView version 4.2** made it possible to specify whether a plugin created with
+the *New Plugin Model* dialog is actually a form factor P(Q) or a structure factor
+S(Q). To do this, simply add one or other of the following lines under the *import*
 statements.
 
@@ -203,13 +195,13 @@
 
      form_factor = True
-	 
+
 or for a structure factor::
 
      structure_factor = True
-	 
-If the plugin is a structure factor it is *also* necessary to add two variables to 
+
+If the plugin is a structure factor it is *also* necessary to add two variables to
 the parameter list::
 
-     parameters = [ 
+     parameters = [
                      ['radius_effective', '', 1, [0.0, numpy.inf], 'volume', ''],
                      ['volfraction', '', 1, [0.0, 1.0], '', ''],
@@ -222,5 +214,5 @@
      def Iqxy(x, y, radius_effective, volfraction, ...):
 
-Such a plugin should then be available in the S(Q) drop-down box on a FitPage (once 
+Such a plugin should then be available in the S(Q) drop-down box on a FitPage (once
 a P(Q) model has been selected).
 
@@ -243,15 +235,15 @@
 them. Finally, click the *Apply* button to generate and test the model and then click *Close*.
 
-Any changes to a plugin model generated in this way only become effective *after* it is re-selected 
-from the plugin models drop-down menu on the FitPage. If the model is not listed you can force a 
+Any changes to a plugin model generated in this way only become effective *after* it is re-selected
+from the plugin models drop-down menu on the FitPage. If the model is not listed you can force a
 recompilation of the plugins by selecting *Fitting* > *Plugin Model Operations* > *Load Plugin Models*.
 
-**SasView version 4.2** introduced a much simplified and more extensible structure for plugin models 
-generated through the Easy Sum/Multi Editor. For example, the code for a combination of a sphere model 
+**SasView version 4.2** introduced a much simplified and more extensible structure for plugin models
+generated through the Easy Sum/Multi Editor. For example, the code for a combination of a sphere model
 with a power law model now looks like this::
 
      from sasmodels.core import load_model_info
      from sasmodels.sasview_model import make_model_from_info
-     
+
      model_info = load_model_info('sphere+power_law')
      model_info.name = 'MyPluginModel'
@@ -259,16 +251,16 @@
      Model = make_model_from_info(model_info)
 
-To change the models or operators contributing to this plugin it is only necessary to edit the string 
-in the brackets after *load_model_info*, though it would also be a good idea to update the model name 
+To change the models or operators contributing to this plugin it is only necessary to edit the string
+in the brackets after *load_model_info*, though it would also be a good idea to update the model name
 and description too!!!
 
-The model specification string can handle multiple models and combinations of operators (+ or *) which 
-are processed according to normal conventions. Thus 'model1+model2*model3' would be valid and would 
-multiply model2 by model3 before adding model1. In this example, parameters in the *FitPage* would be 
-prefixed A (for model2), B (for model3) and C (for model1). Whilst this might appear a little 
-confusing, unless you were creating a plugin model from multiple instances of the same model the parameter 
+The model specification string can handle multiple models and combinations of operators (+ or *) which
+are processed according to normal conventions. Thus 'model1+model2*model3' would be valid and would
+multiply model2 by model3 before adding model1. In this example, parameters in the *FitPage* would be
+prefixed A (for model2), B (for model3) and C (for model1). Whilst this might appear a little
+confusing, unless you were creating a plugin model from multiple instances of the same model the parameter
 assignments ought to be obvious when you load the plugin.
 
-If you need to include another plugin model in the model specification string, just prefix the name of 
+If you need to include another plugin model in the model specification string, just prefix the name of
 that model with *custom*. For instance::
 
@@ -278,8 +270,8 @@
 
      sphere@hardsphere
-     
-This streamlined approach to building complex plugin models from existing library models, or models 
-available on the *Model Marketplace*, also permits the creation of P(Q)*\S(Q) plugin models, something 
-that was not possible in earlier versions of SasView. 
+
+This streamlined approach to building complex plugin models from existing library models, or models
+available on the *Model Marketplace*, also permits the creation of P(Q)*\S(Q) plugin models, something
+that was not possible in earlier versions of SasView.
 
 .. _Advanced_Plugin_Editor:
@@ -471,5 +463,5 @@
 
 This mode is an extension of the :ref:`Single_Fit_Mode` that fits two or more data
-sets *to the same model* simultaneously. If necessary it is possible to constrain 
+sets *to the same model* simultaneously. If necessary it is possible to constrain
 fit parameters between data sets (eg, to fix a background level, or radius, etc).
 
@@ -689,5 +681,5 @@
 recognises the operators +, -, \*, /, or 'pow', and allows the following
 types of expression :
- 
+
   1) if an axis label range is a function of 1 or more *columns*, write
      this type of expression
@@ -706,5 +698,5 @@
 
      Example: radius [2 : 5] , radius [10 : 25]
-     
+
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
 
@@ -756,5 +748,5 @@
    p#_ appended to the beginning and thus radius and p1_radius will not be
    recognized as the same parameter.
-   
+
 .. image:: combine_batch_grid.png
 
@@ -764,5 +756,5 @@
 time is not listed in the file but the file name contains the information. As
 described in :ref:`Grid_Window`, a column can be added manually, in this case
-called time, and the peak position plotted against time. 
+called time, and the peak position plotted against time.
 
 .. image:: combine_batch_plot.png